
'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

if (!global._babelPolyfill) require('babel-polyfill');

var _require = require('path'),
    dirname = _require.dirname,
    join = _require.join,
    resolve = _require.resolve;

var _require2 = require('fs'),
    exists = _require2.exists,
    writeFile = _require2.writeFile,
    readFile = _require2.readFile,
    rename = _require2.rename;

var _require3 = require('fs-extra'),
    readJson = _require3.readJson,
    emptyDir = _require3.emptyDir,
    copy = _require3.copy,
    remove = _require3.remove;

var _require4 = require('child_process'),
    exec = _require4.exec;

var assert = require('assert');

var format = require('string-template');

var temp = require('temp').track();

var glob = require('glob');

var plist = require('plist');

var Flow = require('node-async-flow');

var NWD = require('nwjs-download');

var NWB = require('../../');

var BuildDarwinBinary = function BuildDarwinBinary(path, binaryDir, version, platform, arch, _ref, callback) {
    var _ref$outputDir = _ref.outputDir,
        outputDir = _ref$outputDir === undefined ? null : _ref$outputDir,
        _ref$outputName = _ref.outputName,
        outputName = _ref$outputName === undefined ? null : _ref$outputName,
        _ref$executableName = _ref.executableName,
        executableName = _ref$executableName === undefined ? null : _ref$executableName,
        _ref$outputFormat = _ref.outputFormat,
        outputFormat = _ref$outputFormat === undefined ? null : _ref$outputFormat,
        _ref$includes = _ref.includes,
        includes = _ref$includes === undefined ? null : _ref$includes,
        _ref$withFFmpeg = _ref.withFFmpeg,
        withFFmpeg = _ref$withFFmpeg === undefined ? false : _ref$withFFmpeg,
        _ref$sideBySide = _ref.sideBySide,
        sideBySide = _ref$sideBySide === undefined ? false : _ref$sideBySide,
        _ref$production = _ref.production,
        production = _ref$production === undefined ? false : _ref$production,
        _ref$macIcns = _ref.macIcns,
        macIcns = _ref$macIcns === undefined ? null : _ref$macIcns;


    var context = {};

    Flow( /*#__PURE__*/regeneratorRuntime.mark(function _callee(cb) {
        var majorIdx, err, manifest, _ref2, _ref3, _err, _ref4, _ref5, _err2, REGEX_FILTER_I18N, REGEX_FILTER_DONE, _err3, tempDir, _ref6, _ref7, _ref8, _ref9, _err4, workingDir, _ref10, _ref11, _err5, stdout, stderr, nodeModules, _ref12, _ref13, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, src, gl, dest, _err6, files, srcDir, destDir, _ref14, _ref15, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, file, _src, _dest, _err7, pl, infoFile, _ref16, _ref17, properties, _err8, _err9, _err10, newName, _err11, zipFile, _ref18, _ref19;

        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        majorIdx = 0;
                        err = void 0, manifest = void 0;


                        console.log(majorIdx++ + ': Read package.json');

                        _context.next = 5;
                        return readJson(join(path, 'package.json'), cb.expect(2));

                    case 5:
                        _ref2 = _context.sent;
                        _ref3 = _slicedToArray(_ref2, 2);
                        err = _ref3[0];
                        manifest = _ref3[1];

                        if (!err) {
                            _context.next = 11;
                            break;
                        }

                        return _context.abrupt('return', callback(err));

                    case 11:

                        this.manifest = manifest;
                        this.target = NWD.GetTarget(platform, arch);
                        this.buildName = format(outputName ? outputName : '{name}-{target}', {
                            name: manifest.name,
                            version: manifest.version,
                            platform: platform,
                            arch: arch,
                            target: this.target
                        });
                        this.buildDir = outputDir ? join(outputDir, this.buildName) : join(dirname(path), this.buildName);

                        _err = void 0;


                        console.log(majorIdx++ + ': Prepare build directory at ' + this.buildDir);

                        _context.next = 19;
                        return emptyDir(this.buildDir, cb.expect(2));

                    case 19:
                        _ref4 = _context.sent;
                        _ref5 = _slicedToArray(_ref4, 1);
                        _err = _ref5[0];

                        if (!_err) {
                            _context.next = 24;
                            break;
                        }

                        return _context.abrupt('return', callback(_err));

                    case 24:
                        _err2 = void 0;


                        console.log(majorIdx++ + ': Copy binary from ' + binaryDir);

                        REGEX_FILTER_I18N = /[\\\/]nwjs\.app[\\\/]Contents[\\\/]Resources[\\\/][a-zA-Z0-9_]+\.lproj/;
                        REGEX_FILTER_DONE = /[\\\/]\.done/;
                        _context.next = 30;
                        return copy(binaryDir, this.buildDir, {
                            // Ignore i18n files.
                            filter: function filter(path) {
                                return !REGEX_FILTER_I18N.test(path) && !REGEX_FILTER_DONE.test(path);
                            }
                        }, cb.single);

                    case 30:
                        _err2 = _context.sent;

                        if (!_err2) {
                            _context.next = 33;
                            break;
                        }

                        return _context.abrupt('return', callback(_err2));

                    case 33:
                        if (!withFFmpeg) {
                            _context.next = 56;
                            break;
                        }

                        _err3 = void 0, tempDir = void 0;


                        console.log(majorIdx++ + ': Install ffmpeg for nw.js ' + version);

                        // Make a temporary directory.

                        _context.next = 38;
                        return temp.mkdir(null, cb.expect(2));

                    case 38:
                        _ref6 = _context.sent;
                        _ref7 = _slicedToArray(_ref6, 2);
                        _err3 = _ref7[0];
                        tempDir = _ref7[1];

                        if (!_err3) {
                            _context.next = 44;
                            break;
                        }

                        return _context.abrupt('return', callback(_err3));

                    case 44:
                        _context.next = 46;
                        return NWB.DownloadAndExtractFFmpeg(tempDir, {
                            version: version, platform: platform, arch: arch
                        }, cb.expect(3));

                    case 46:
                        _ref8 = _context.sent;
                        _ref9 = _slicedToArray(_ref8, 2);
                        _err3 = _ref9[0];

                        if (!_err3) {
                            _context.next = 51;
                            break;
                        }

                        return _context.abrupt('return', callback(_err3));

                    case 51:
                        _context.next = 53;
                        return NWB.InstallFFmpeg(tempDir, this.buildDir, platform, cb.single);

                    case 53:
                        _err3 = _context.sent;

                        if (!_err3) {
                            _context.next = 56;
                            break;
                        }

                        return _context.abrupt('return', callback(_err3));

                    case 56:
                        _err4 = void 0, workingDir = void 0;


                        console.log(majorIdx++ + ': Make working directory');

                        _context.next = 60;
                        return temp.mkdir(null, cb.expect(2));

                    case 60:
                        _ref10 = _context.sent;
                        _ref11 = _slicedToArray(_ref10, 2);
                        _err4 = _ref11[0];
                        workingDir = _ref11[1];

                        if (!_err4) {
                            _context.next = 66;
                            break;
                        }

                        return _context.abrupt('return', callback(_err4));

                    case 66:
                        _context.next = 68;
                        return copy(path, workingDir, cb.single);

                    case 68:
                        _err4 = _context.sent;

                        if (!_err4) {
                            _context.next = 71;
                            break;
                        }

                        return _context.abrupt('return', callback(_err4));

                    case 71:

                        this.workingDir = workingDir;

                        if (!production) {
                            _context.next = 92;
                            break;
                        }

                        _err5 = void 0, stdout = void 0, stderr = void 0;
                        nodeModules = join(this.workingDir, 'node_modules');


                        console.log(majorIdx++ + ': Remove node_modules at ' + nodeModules);

                        _context.next = 78;
                        return remove(nodeModules, cb.single);

                    case 78:
                        _err5 = _context.sent;

                        if (!_err5) {
                            _context.next = 81;
                            break;
                        }

                        return _context.abrupt('return', callback(_err5));

                    case 81:

                        console.log(majorIdx++ + ': Execute npm install at ' + this.workingDir);

                        _context.next = 84;
                        return exec('npm install', {
                            cwd: this.workingDir
                        }, cb.expect(3));

                    case 84:
                        _ref12 = _context.sent;
                        _ref13 = _slicedToArray(_ref12, 3);
                        _err5 = _ref13[0];
                        stdout = _ref13[1];
                        stderr = _ref13[2];

                        if (!_err5) {
                            _context.next = 91;
                            break;
                        }

                        return _context.abrupt('return', callback(_err5));

                    case 91:

                        //console.log(stdout);
                        console.log(stderr);

                    case 92:
                        if (!includes) {
                            _context.next = 160;
                            break;
                        }

                        console.log(majorIdx++ + ': Copy included files to ' + this.workingDir);

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 97;
                        _iterator = includes[Symbol.iterator]();

                    case 99:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context.next = 146;
                            break;
                        }

                        _step$value = _slicedToArray(_step.value, 3), src = _step$value[0], gl = _step$value[1], dest = _step$value[2];
                        _err6 = void 0, files = void 0;
                        srcDir = resolve(src);
                        destDir = resolve(join(this.workingDir, dest));
                        _context.next = 106;
                        return glob(gl, {
                            cwd: srcDir
                        }, cb.expect(2));

                    case 106:
                        _ref14 = _context.sent;
                        _ref15 = _slicedToArray(_ref14, 2);
                        _err6 = _ref15[0];
                        files = _ref15[1];

                        if (!_err6) {
                            _context.next = 112;
                            break;
                        }

                        return _context.abrupt('return', callback(_err6));

                    case 112:
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context.prev = 115;
                        _iterator2 = files[Symbol.iterator]();

                    case 117:
                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                            _context.next = 129;
                            break;
                        }

                        file = _step2.value;
                        _src = resolve(join(srcDir, file));
                        _dest = resolve(join(destDir, file));
                        _context.next = 123;
                        return copy(_src, _dest, cb.single);

                    case 123:
                        _err6 = _context.sent;

                        if (!_err6) {
                            _context.next = 126;
                            break;
                        }

                        return _context.abrupt('return', callback(_err6));

                    case 126:
                        _iteratorNormalCompletion2 = true;
                        _context.next = 117;
                        break;

                    case 129:
                        _context.next = 135;
                        break;

                    case 131:
                        _context.prev = 131;
                        _context.t0 = _context['catch'](115);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context.t0;

                    case 135:
                        _context.prev = 135;
                        _context.prev = 136;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 138:
                        _context.prev = 138;

                        if (!_didIteratorError2) {
                            _context.next = 141;
                            break;
                        }

                        throw _iteratorError2;

                    case 141:
                        return _context.finish(138);

                    case 142:
                        return _context.finish(135);

                    case 143:
                        _iteratorNormalCompletion = true;
                        _context.next = 99;
                        break;

                    case 146:
                        _context.next = 152;
                        break;

                    case 148:
                        _context.prev = 148;
                        _context.t1 = _context['catch'](97);
                        _didIteratorError = true;
                        _iteratorError = _context.t1;

                    case 152:
                        _context.prev = 152;
                        _context.prev = 153;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 155:
                        _context.prev = 155;

                        if (!_didIteratorError) {
                            _context.next = 158;
                            break;
                        }

                        throw _iteratorError;

                    case 158:
                        return _context.finish(155);

                    case 159:
                        return _context.finish(152);

                    case 160:
                        _err7 = void 0, pl = void 0;
                        infoFile = join(this.buildDir, 'nwjs.app', 'Contents', 'Info.plist');


                        console.log(majorIdx++ + ': Modify Info.plist at ' + infoFile);

                        _context.next = 165;
                        return readFile(infoFile, {
                            encoding: 'utf-8'
                        }, function (err, data) {

                            if (err) {
                                return cb.expect(2)(err);
                            }

                            cb.expect(2)(null, plist.parse(data.toString()));
                        });

                    case 165:
                        _ref16 = _context.sent;
                        _ref17 = _slicedToArray(_ref16, 2);
                        _err7 = _ref17[0];
                        pl = _ref17[1];

                        if (!_err7) {
                            _context.next = 171;
                            break;
                        }

                        return _context.abrupt('return', callback(_err7));

                    case 171:

                        assert(this.manifest.name);
                        assert(this.manifest.version);

                        pl['CFBundleDisplayName'] = this.manifest.name;
                        pl['CFBundleName'] = this.manifest.name;
                        pl['CFBundleVersion'] = this.manifest.version;
                        pl['CFBundleShortVersionString'] = this.manifest.version;
                        pl['CFBundleIdentifier'] = 'io.nwjs-builder.' + this.manifest.name.toLowerCase();

                        if (this.manifest.nwjsBuilder) {
                            properties = this.manifest.nwjsBuilder;


                            if (properties.productName) {
                                pl['CFBundleDisplayName'] = properties.productName;
                                pl['CFBundleName'] = properties.productName;
                            }

                            if (properties.productVersion) {
                                pl['CFBundleVersion'] = properties.productVersion;
                                pl['CFBundleShortVersionString'] = properties.productVersion;
                            }

                            if (properties.bundleIdentifier) {
                                pl['CFBundleIdentifier'] = properties.bundleIdentifier;
                            }
                        }

                        _context.next = 181;
                        return writeFile(infoFile, plist.build(pl), cb.single);

                    case 181:
                        _err7 = _context.sent;

                        if (!_err7) {
                            _context.next = 184;
                            break;
                        }

                        return _context.abrupt('return', callback(_err7));

                    case 184:
                        if (!macIcns) {
                            _context.next = 205;
                            break;
                        }

                        _err8 = void 0, dest = void 0;


                        console.log(majorIdx++ + ': Copy .icns to ' + this.buildDir);

                        // For nw.js 0.12.x.
                        dest = join(this.buildDir, 'nwjs.app', 'Contents', 'Resources', 'nw.icns');
                        _context.next = 190;
                        return exists(dest, cb.single);

                    case 190:
                        if (!_context.sent) {
                            _context.next = 196;
                            break;
                        }

                        _context.next = 193;
                        return copy(macIcns, dest, cb.single);

                    case 193:
                        _err8 = _context.sent;

                        if (!_err8) {
                            _context.next = 196;
                            break;
                        }

                        return _context.abrupt('return', callback(_err8));

                    case 196:

                        // For modern nw.js.
                        dest = join(this.buildDir, 'nwjs.app', 'Contents', 'Resources', 'app.icns');
                        _context.next = 199;
                        return exists(dest, cb.single);

                    case 199:
                        if (!_context.sent) {
                            _context.next = 205;
                            break;
                        }

                        _context.next = 202;
                        return copy(macIcns, dest, cb.single);

                    case 202:
                        _err8 = _context.sent;

                        if (!_err8) {
                            _context.next = 205;
                            break;
                        }

                        return _context.abrupt('return', callback(_err8));

                    case 205:
                        _err9 = void 0;


                        console.log(majorIdx++ + ': Copy application from ' + this.workingDir);

                        _context.next = 209;
                        return copy(this.workingDir, join(this.buildDir, 'nwjs.app', 'Contents', 'Resources', 'app.nw'), cb.single);

                    case 209:
                        _err9 = _context.sent;

                        if (!_err9) {
                            _context.next = 212;
                            break;
                        }

                        return _context.abrupt('return', callback(_err9));

                    case 212:
                        _err10 = void 0;
                        newName = (executableName ? executableName : this.manifest.name) + '.app';


                        console.log(majorIdx++ + ': Rename application to ' + newName);

                        _context.next = 217;
                        return rename(join(this.buildDir, 'nwjs.app'), join(this.buildDir, newName), cb.single);

                    case 217:
                        _err10 = _context.sent;

                        if (!_err10) {
                            _context.next = 220;
                            break;
                        }

                        return _context.abrupt('return', callback(_err10));

                    case 220:
                        if (!(outputFormat == 'ZIP')) {
                            _context.next = 237;
                            break;
                        }

                        _err11 = void 0;
                        zipFile = this.buildDir + '.zip';


                        console.log(majorIdx++ + ': Zip to ' + zipFile);

                        _context.next = 226;
                        return NWB.util.ZipDirectory(this.buildDir, [], zipFile, cb.expect(2));

                    case 226:
                        _ref18 = _context.sent;
                        _ref19 = _slicedToArray(_ref18, 1);
                        _err11 = _ref19[0];

                        if (!_err11) {
                            _context.next = 231;
                            break;
                        }

                        return _context.abrupt('return', callback(_err11));

                    case 231:

                        console.log(majorIdx++ + ': Clean up ' + this.buildDir);

                        _context.next = 234;
                        return remove(this.buildDir, cb.single);

                    case 234:
                        _err11 = _context.sent;

                        if (!_err11) {
                            _context.next = 237;
                            break;
                        }

                        return _context.abrupt('return', callback(_err11));

                    case 237:

                        console.log(majorIdx++ + ': Done');

                        callback(null, this.buildDir);

                    case 239:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[97, 148, 152, 160], [115, 131, 135, 143], [136,, 138, 142], [153,, 155, 159]]);
    }).bind(context));
};

module.exports = BuildDarwinBinary;