
'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

if (!global._babelPolyfill) require('babel-polyfill');

var _require = require('path'),
    dirname = _require.dirname,
    join = _require.join,
    resolve = _require.resolve;

var _require2 = require('fs'),
    rename = _require2.rename;

var _require3 = require('fs-extra'),
    readJson = _require3.readJson,
    emptyDir = _require3.emptyDir,
    copy = _require3.copy,
    remove = _require3.remove;

var _require4 = require('child_process'),
    exec = _require4.exec;

var assert = require('assert');

var format = require('string-template');

var temp = require('temp').track();

var glob = require('glob');

var rcedit = require('rcedit');
var resourceHacker = require('node-resourcehacker');

var Flow = require('node-async-flow');

var NWD = require('nwjs-download');

var NWB = require('../../');

var BuildWin32Binary = function BuildWin32Binary(path, binaryDir, version, platform, arch, _ref, callback) {
    var _ref$outputDir = _ref.outputDir,
        outputDir = _ref$outputDir === undefined ? null : _ref$outputDir,
        _ref$outputName = _ref.outputName,
        outputName = _ref$outputName === undefined ? null : _ref$outputName,
        _ref$executableName = _ref.executableName,
        executableName = _ref$executableName === undefined ? null : _ref$executableName,
        _ref$outputFormat = _ref.outputFormat,
        outputFormat = _ref$outputFormat === undefined ? null : _ref$outputFormat,
        _ref$includes = _ref.includes,
        includes = _ref$includes === undefined ? null : _ref$includes,
        _ref$withFFmpeg = _ref.withFFmpeg,
        withFFmpeg = _ref$withFFmpeg === undefined ? false : _ref$withFFmpeg,
        _ref$sideBySide = _ref.sideBySide,
        sideBySide = _ref$sideBySide === undefined ? false : _ref$sideBySide,
        _ref$production = _ref.production,
        production = _ref$production === undefined ? false : _ref$production,
        _ref$winIco = _ref.winIco,
        winIco = _ref$winIco === undefined ? null : _ref$winIco;


    var context = {};

    Flow( /*#__PURE__*/regeneratorRuntime.mark(function _callee(cb) {
        var majorIdx, err, manifest, _ref2, _ref3, _err, _ref4, _ref5, _err2, REGEX_FILTER_DONE, _err3, rcOptions, properties, _err4, tempDir, _ref6, _ref7, _ref8, _ref9, _err5, workingDir, _ref10, _ref11, _err6, stdout, stderr, nodeModules, _ref12, _ref13, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, src, gl, dest, _err7, files, srcDir, destDir, _ref14, _ref15, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, file, _src, _dest, _err8, _err9, nwFile, _ref16, _ref17, executable, _err10, newName, _err11, zipFile, _ref18, _ref19;

        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        majorIdx = 0;
                        err = void 0, manifest = void 0;


                        console.log(majorIdx++ + ': Read package.json');

                        _context.next = 5;
                        return readJson(join(path, 'package.json'), cb.expect(2));

                    case 5:
                        _ref2 = _context.sent;
                        _ref3 = _slicedToArray(_ref2, 2);
                        err = _ref3[0];
                        manifest = _ref3[1];

                        if (!err) {
                            _context.next = 11;
                            break;
                        }

                        return _context.abrupt('return', callback(err));

                    case 11:

                        this.manifest = manifest;
                        this.target = NWD.GetTarget(platform, arch);
                        this.buildName = format(outputName ? outputName : '{name}-{target}', {
                            name: manifest.name,
                            version: manifest.version,
                            platform: platform,
                            arch: arch,
                            target: this.target
                        });
                        this.buildDir = outputDir ? join(outputDir, this.buildName) : join(dirname(path), this.buildName);

                        _err = void 0;


                        console.log(majorIdx++ + ': Prepare build directory at ' + this.buildDir);

                        _context.next = 19;
                        return emptyDir(this.buildDir, cb.expect(2));

                    case 19:
                        _ref4 = _context.sent;
                        _ref5 = _slicedToArray(_ref4, 1);
                        _err = _ref5[0];

                        if (!_err) {
                            _context.next = 24;
                            break;
                        }

                        return _context.abrupt('return', callback(_err));

                    case 24:
                        _err2 = void 0;


                        console.log(majorIdx++ + ': Copy binary from ' + binaryDir);

                        REGEX_FILTER_DONE = /[\\\/]\.done/;
                        _context.next = 29;
                        return copy(binaryDir, this.buildDir, {
                            filter: function filter(path) {
                                return !REGEX_FILTER_DONE.test(path);
                            }
                        }, cb.single);

                    case 29:
                        _err2 = _context.sent;

                        if (!_err2) {
                            _context.next = 32;
                            break;
                        }

                        return _context.abrupt('return', callback(_err2));

                    case 32:
                        _err3 = void 0;


                        console.log(majorIdx++ + ': Edit Windows executable');

                        rcOptions = {
                            'version-string': {
                                // Comments: undefined,
                                // CompanyName: undefined,
                                // FileDescription: manifest.description,
                                // FileVersion: manifest.version,
                                // InternalName: undefined,
                                // LegalCopyright: undefined,
                                // LegalTrademarks: undefined,
                                // OriginalFilename: undefined,
                                // PrivateBuild: undefined,
                                // ProductName: manifest.name,
                                // ProductVersion: manifest.version,
                                // SpecialBuild: undefined,
                            }
                        };


                        assert(this.manifest.name);
                        assert(this.manifest.version);

                        rcOptions['version-string'].ProductName = this.manifest.name;
                        rcOptions['product-version'] = this.manifest.version;

                        if (this.manifest.description) {
                            rcOptions['version-string'].FileDescription = this.manifest.description;
                        }

                        if (this.manifest.nwjsBuilder) {
                            properties = this.manifest.nwjsBuilder;


                            if (properties.productName) {
                                rcOptions['version-string'].ProductName = properties.productName;
                            }

                            if (properties.productVersion) {
                                rcOptions['product-version'] = properties.productVersion;
                            }

                            if (properties.fileDescription) {
                                rcOptions['version-string'].FileDescription = properties.fileDescription;
                            }

                            if (properties.copyright) {
                                rcOptions['version-string'].LegalCopyright = properties.copyright;
                            }

                            if (properties.internalName) {
                                rcOptions['version-string'].InternalName = properties.internalName;
                            }

                            if (properties.fileVersion) {
                                rcOptions['file-version'] = properties.fileVersion;
                            }

                            if (properties.comments) {
                                rcOptions['version-string'].Comments = properties.comments;
                            }

                            if (properties.companyName) {
                                rcOptions['version-string'].CompanyName = properties.companyName;
                            }

                            if (properties.legalTrademarks) {
                                rcOptions['version-string'].LegalTrademarks = properties.legalTrademarks;
                            }

                            if (properties.originalFilename) {
                                rcOptions['version-string'].OriginalFilename = properties.originalFilename;
                            }

                            if (properties.privateBuild) {
                                rcOptions['version-string'].PrivateBuild = properties.privateBuild;
                            }

                            if (properties.specialBuild) {
                                rcOptions['version-string'].SpecialBuild = properties.specialBuild;
                            }
                        }

                        _context.next = 43;
                        return rcedit(join(this.buildDir, 'nw.exe'), rcOptions, cb.single);

                    case 43:
                        _err3 = _context.sent;


                        if (_err3) {
                            console.warn(_err3);
                        }

                        if (!winIco) {
                            _context.next = 50;
                            break;
                        }

                        _context.next = 48;
                        return resourceHacker({
                            operation: 'addoverwrite',
                            input: join(this.buildDir, 'nw.exe'),
                            output: join(this.buildDir, 'nw.exe'),
                            resource: winIco,
                            resourceType: 'ICONGROUP',
                            resourceName: 'IDR_MAINFRAME'
                        }, cb.single);

                    case 48:
                        _err3 = _context.sent;


                        if (_err3) {
                            console.warn(_err3);
                        }

                    case 50:
                        if (!withFFmpeg) {
                            _context.next = 73;
                            break;
                        }

                        _err4 = void 0, tempDir = void 0;


                        console.log(majorIdx++ + ': Install ffmpeg for nw.js ' + version);

                        // Make a temporary directory.

                        _context.next = 55;
                        return temp.mkdir(null, cb.expect(2));

                    case 55:
                        _ref6 = _context.sent;
                        _ref7 = _slicedToArray(_ref6, 2);
                        _err4 = _ref7[0];
                        tempDir = _ref7[1];

                        if (!_err4) {
                            _context.next = 61;
                            break;
                        }

                        return _context.abrupt('return', callback(_err4));

                    case 61:
                        _context.next = 63;
                        return NWB.DownloadAndExtractFFmpeg(tempDir, {
                            version: version, platform: platform, arch: arch
                        }, cb.expect(3));

                    case 63:
                        _ref8 = _context.sent;
                        _ref9 = _slicedToArray(_ref8, 2);
                        _err4 = _ref9[0];

                        if (!_err4) {
                            _context.next = 68;
                            break;
                        }

                        return _context.abrupt('return', callback(_err4));

                    case 68:
                        _context.next = 70;
                        return NWB.InstallFFmpeg(tempDir, this.buildDir, platform, cb.single);

                    case 70:
                        _err4 = _context.sent;

                        if (!_err4) {
                            _context.next = 73;
                            break;
                        }

                        return _context.abrupt('return', callback(_err4));

                    case 73:
                        _err5 = void 0, workingDir = void 0;


                        console.log(majorIdx++ + ': Make working directory');

                        _context.next = 77;
                        return temp.mkdir(null, cb.expect(2));

                    case 77:
                        _ref10 = _context.sent;
                        _ref11 = _slicedToArray(_ref10, 2);
                        _err5 = _ref11[0];
                        workingDir = _ref11[1];

                        if (!_err5) {
                            _context.next = 83;
                            break;
                        }

                        return _context.abrupt('return', callback(_err5));

                    case 83:
                        _context.next = 85;
                        return copy(path, workingDir, cb.single);

                    case 85:
                        _err5 = _context.sent;

                        if (!_err5) {
                            _context.next = 88;
                            break;
                        }

                        return _context.abrupt('return', callback(_err5));

                    case 88:

                        this.workingDir = workingDir;

                        if (!production) {
                            _context.next = 109;
                            break;
                        }

                        _err6 = void 0, stdout = void 0, stderr = void 0;
                        nodeModules = join(this.workingDir, 'node_modules');


                        console.log(majorIdx++ + ': Remove node_modules at ' + nodeModules);

                        _context.next = 95;
                        return remove(nodeModules, cb.single);

                    case 95:
                        _err6 = _context.sent;

                        if (!_err6) {
                            _context.next = 98;
                            break;
                        }

                        return _context.abrupt('return', callback(_err6));

                    case 98:

                        console.log(majorIdx++ + ': Execute npm install at ' + this.workingDir);

                        _context.next = 101;
                        return exec('npm install', {
                            cwd: this.workingDir
                        }, cb.expect(3));

                    case 101:
                        _ref12 = _context.sent;
                        _ref13 = _slicedToArray(_ref12, 3);
                        _err6 = _ref13[0];
                        stdout = _ref13[1];
                        stderr = _ref13[2];

                        if (!_err6) {
                            _context.next = 108;
                            break;
                        }

                        return _context.abrupt('return', callback(_err6));

                    case 108:

                        //console.log(stdout);
                        console.log(stderr);

                    case 109:
                        if (!includes) {
                            _context.next = 177;
                            break;
                        }

                        console.log(majorIdx++ + ': Copy included files to ' + this.workingDir);

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 114;
                        _iterator = includes[Symbol.iterator]();

                    case 116:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            _context.next = 163;
                            break;
                        }

                        _step$value = _slicedToArray(_step.value, 3), src = _step$value[0], gl = _step$value[1], dest = _step$value[2];
                        _err7 = void 0, files = void 0;
                        srcDir = resolve(src);
                        destDir = resolve(join(this.workingDir, dest));
                        _context.next = 123;
                        return glob(gl, {
                            cwd: srcDir
                        }, cb.expect(2));

                    case 123:
                        _ref14 = _context.sent;
                        _ref15 = _slicedToArray(_ref14, 2);
                        _err7 = _ref15[0];
                        files = _ref15[1];

                        if (!_err7) {
                            _context.next = 129;
                            break;
                        }

                        return _context.abrupt('return', callback(_err7));

                    case 129:
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        _context.prev = 132;
                        _iterator2 = files[Symbol.iterator]();

                    case 134:
                        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                            _context.next = 146;
                            break;
                        }

                        file = _step2.value;
                        _src = resolve(join(srcDir, file));
                        _dest = resolve(join(destDir, file));
                        _context.next = 140;
                        return copy(_src, _dest, cb.single);

                    case 140:
                        _err7 = _context.sent;

                        if (!_err7) {
                            _context.next = 143;
                            break;
                        }

                        return _context.abrupt('return', callback(_err7));

                    case 143:
                        _iteratorNormalCompletion2 = true;
                        _context.next = 134;
                        break;

                    case 146:
                        _context.next = 152;
                        break;

                    case 148:
                        _context.prev = 148;
                        _context.t0 = _context['catch'](132);
                        _didIteratorError2 = true;
                        _iteratorError2 = _context.t0;

                    case 152:
                        _context.prev = 152;
                        _context.prev = 153;

                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }

                    case 155:
                        _context.prev = 155;

                        if (!_didIteratorError2) {
                            _context.next = 158;
                            break;
                        }

                        throw _iteratorError2;

                    case 158:
                        return _context.finish(155);

                    case 159:
                        return _context.finish(152);

                    case 160:
                        _iteratorNormalCompletion = true;
                        _context.next = 116;
                        break;

                    case 163:
                        _context.next = 169;
                        break;

                    case 165:
                        _context.prev = 165;
                        _context.t1 = _context['catch'](114);
                        _didIteratorError = true;
                        _iteratorError = _context.t1;

                    case 169:
                        _context.prev = 169;
                        _context.prev = 170;

                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }

                    case 172:
                        _context.prev = 172;

                        if (!_didIteratorError) {
                            _context.next = 175;
                            break;
                        }

                        throw _iteratorError;

                    case 175:
                        return _context.finish(172);

                    case 176:
                        return _context.finish(169);

                    case 177:
                        if (!sideBySide) {
                            _context.next = 187;
                            break;
                        }

                        _err8 = void 0;


                        console.log(majorIdx++ + ': Copy application from ' + this.workingDir);

                        _context.next = 182;
                        return copy(this.workingDir, this.buildDir, cb.single);

                    case 182:
                        _err8 = _context.sent;

                        if (!_err8) {
                            _context.next = 185;
                            break;
                        }

                        return _context.abrupt('return', callback(_err8));

                    case 185:
                        _context.next = 204;
                        break;

                    case 187:
                        _err9 = void 0, nwFile = void 0;


                        console.log(majorIdx++ + ': Compress application');

                        _context.next = 191;
                        return NWB.util.ZipDirectory(this.workingDir, [], temp.path(), cb.expect(2));

                    case 191:
                        _ref16 = _context.sent;
                        _ref17 = _slicedToArray(_ref16, 2);
                        _err9 = _ref17[0];
                        nwFile = _ref17[1];

                        if (!_err9) {
                            _context.next = 197;
                            break;
                        }

                        return _context.abrupt('return', callback(_err9));

                    case 197:
                        executable = NWB.GetExecutable(this.buildDir, this.target);


                        console.log(majorIdx++ + ': Combine executable at ' + executable);

                        _context.next = 201;
                        return NWB.util.CombineExecutable(executable, nwFile, cb.single);

                    case 201:
                        _err9 = _context.sent;

                        if (!_err9) {
                            _context.next = 204;
                            break;
                        }

                        return _context.abrupt('return', callback(_err9));

                    case 204:
                        _err10 = void 0;
                        newName = (executableName ? executableName : this.manifest.name) + '.exe';


                        console.log(majorIdx++ + ': Rename application to ' + newName);

                        _context.next = 209;
                        return rename(join(this.buildDir, 'nw.exe'), join(this.buildDir, newName), cb.single);

                    case 209:
                        _err10 = _context.sent;

                        if (!_err10) {
                            _context.next = 212;
                            break;
                        }

                        return _context.abrupt('return', callback(_err10));

                    case 212:
                        if (!(outputFormat == 'ZIP')) {
                            _context.next = 229;
                            break;
                        }

                        _err11 = void 0;
                        zipFile = this.buildDir + '.zip';


                        console.log(majorIdx++ + ': Zip to ' + zipFile);

                        _context.next = 218;
                        return NWB.util.ZipDirectory(this.buildDir, [], zipFile, cb.expect(2));

                    case 218:
                        _ref18 = _context.sent;
                        _ref19 = _slicedToArray(_ref18, 1);
                        _err11 = _ref19[0];

                        if (!_err11) {
                            _context.next = 223;
                            break;
                        }

                        return _context.abrupt('return', callback(_err11));

                    case 223:

                        console.log(majorIdx++ + ': Clean up ' + this.buildDir);

                        _context.next = 226;
                        return remove(this.buildDir, cb.single);

                    case 226:
                        _err11 = _context.sent;

                        if (!_err11) {
                            _context.next = 229;
                            break;
                        }

                        return _context.abrupt('return', callback(_err11));

                    case 229:

                        console.log(majorIdx++ + ': Done');

                        callback(null, this.buildDir);

                    case 231:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[114, 165, 169, 177], [132, 148, 152, 160], [153,, 155, 159], [170,, 172, 176]]);
    }).bind(context));
};

module.exports = BuildWin32Binary;